//garand.cs

//audio
datablock AudioProfile(garandshotSound)
{
   filename    = "./sound/garandshot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(garandclipinSound)
{
   filename    = "./sound/garand_clipintwo.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(garandboltinSound)
{
   filename    = "./sound/garand_boltforward.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(garanddingSound)
{
   filename    = "./sound/garand_clipding.wav";
   description = AudioClose3d;
   preload = true;
};




if($ammo::default["garand"]$="")$ammo::default["garand"]=8;
datablock DebrisData(garandShellDebris)
{
	shapeFile = "./garandShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
datablock ParticleData(garandSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "./spark00";
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "1.0 0.36 0.26 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.2;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(garandSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 100;
   particles = "garandSparks";
};


//muzzle flash effects
datablock ParticleData(garandFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(garandFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "garandFlashParticle";


};

datablock ParticleData(garandExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 150;
   textureName          = "./smoke";

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(garandExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "garandExplosionParticle";
};
datablock ParticleData(garandImpactSmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "./particleTest";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(garandImpactSmoke)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "garandImpactSmokeParticle";
   lifetimeMS       = 50;
};


datablock ExplosionData(garandExplosion)
{
	soundProfile = bulletHitSound;


   //emitter[0] = garandImpactSmoke;
   emitter[0] = garandSparkEmitter;
   emitter[1] = garandImpactSmoke;
   faceViewer           = false;
};





datablock ProjectileData(garandProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::garand;
   radiusDamageType    = $DamageType::garand;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 500;
   verticalImpulse	  = 0;
   explosion           = garandExplosion;
   particleEmitter     = garandgarandbulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};


//////////
// item //
//////////
datablock ItemData(garandItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./garandnohand.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = ".30-60 Rifle";
	iconName = "./garand";
	doColorShift = false;
	colorShiftColor = "0.6 0.6 0.6 1.000";

	 // Dynamic properties defined by the scripts
	image = garandImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(garandImage)
{
   // Basic Item properties
   shapeFile = "./garand4.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;//"0 0.6 -0.28"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = garandProjectile;
   projectileType = Projectile;

	casing = garandShellDebris;
	shellExitDir        = "0.0 0.0 2.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.6 0.6 0.6 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.0;
	stateSequence[0]                = "activate";
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[1]                     = "Ready";
	stateSequence[1]	= "Ready";
	statescript[1]="checkammo";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= garandFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	statetransitionOnNoAmmo[3]      = "clipinpause";
	stateSound[2]					= garandshotSound;
	stateEjectShell[2]       = true;

	
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.3;
	statetransitionOnNoAmmo[3]      = "ding";
	stateTransitionOnTimeout[3]     = "checkfire";
	//---------LINE OF SEPERATION :/-------------------------------	
	stateName[4]			= "checkfire";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

		//---------LINE OF SEPERATION :/-------------------------------
	stateName[5]			= "ding";
	stateSequence[5]                = "noammo";
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]			= true;
	stateTimeoutValue[5]            = 0.3;
	stateSound[5]				= garanddingSound;
	stateTransitionOnTimeout[5]     = "boltout";
			//---------LINE OF SEPERATION :/-------------------------------
	stateName[6]			= "boltout";
	stateSequence[6]                = "noammo";
	stateAllowImageChange[6]        = true;
	stateWaitForTimeout[6]			= true;
	stateTimeoutValue[6]            = 0.1;
	stateTransitionOnTimeout[6]     = "clipinpause";
					//---------LINE OF SEPERATION :/-------------------------------
	stateName[7]			= "clipinpause";
	stateAllowImageChange[7]        = true;
	stateSequence[7]                = "clipin";
	stateWaitForTimeout[7]			= true;
	stateTimeoutValue[7]            = 0.1;
	stateSound[7]					= garandclipinSound;
	stateTransitionOnTimeout[7]     = "clipin";
				//---------LINE OF SEPERATION :/-------------------------------
	stateName[8]			= "clipin";
	//stateSequence[8]                = "clipin";	
	stateAllowImageChange[8]        = true;
	stateWaitForTimeout[8]			= true;
	stateTimeoutValue[8]            = 0.5;
	//stateSound[8]					= garandclipinSound;
	stateTransitionOnTimeout[8]     = "boltinpause";
						//---------LINE OF SEPERATION :/-------------------------------
	stateName[9]			= "boltinpause";
	stateAllowImageChange[9]        = true;
	stateWaitForTimeout[9]			= true;
	stateTimeoutValue[9]            = 0.03;
	stateSound[9]					= garandboltinSound;
	stateTransitionOnTimeout[9]     = "boltin";
				//---------LINE OF SEPERATION :/-------------------------------
	stateName[10]			= "boltin";
	stateSequence[10]                = "boltin";
	stateAllowImageChange[10]        = true;
	stateWaitForTimeout[10]			= true;
	statescript[10]            = "onreload";
	stateTimeoutValue[10]            = 0.1;
	
	stateTransitionOnTimeout[10]     = "readypause";
	//-----------------------
		stateName[11]			= "readypause";
	stateAllowImageChange[11]        = false;
	stateWaitForTimeout[11]			= true;
	stateTimeoutValue[11]            = 0.2;

	stateTransitionOnTimeout[11]     = "ready";
	
	

};
function garandImage::onMount(%this, %obj, %slot)
{
	  	 %obj.hideNode(lhand);
	  	 %obj.hideNode(lhook);
	     %obj.hideNode(rhand);
	  	 %obj.hideNode(rhook);
		 
//	%color = %obj.getdatablock().skincolor;
	//%this.setNodecolor($hand[0], %color);

}
function garandImage::onUnMount(%this, %obj, %slot)
{
	  	%obj.unhideNode(lhand);
		%obj.unhideNode(rhand);
}
function garandImage::onfire(%this,%obj,%slot)
{
	%player = %obj;
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["garand"]@"/8");
    if(!%obj.ammo["garand"]){%obj.setimageammo(%slot,0);
	return;
	}
	if(vectorLen(%player.getVelocity()) <= 0.1)
	{
	    %obj.setimageammo(%slot,1);
		%obj.ammo["garand"]-=1;
	
		%projectile = garandprojectile;
		%spread = 0.001;
		%shellcount = 1;
	



		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		}
		else//---------------------------------------------if player moves
		{
		%obj.setimageammo(%slot,1);
		%obj.ammo["garand"]-=1;
	
		%projectile = garandprojectile;
		%spread = 0.01;
		%shellcount = 1;
	for(%shell=0; %shell<%shellcount; %shell++)
			{
				%vector = %obj.getMuzzleVector(%slot);
				%objectVelocity = %obj.getVelocity();
				%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
				%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
				%velocity = VectorAdd(%vector1,%vector2);
				%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
	}
	return %p;

}
function garandImage::onreload(%this, %obj, %slot)
{
    if(%obj.ammo["garand"]$=0)
	%obj.ammo["garand"]=8;
    if(%obj.ammount$="")
	%obj.ammount=0;
	    %obj.ammo["garand"]+=%obj.ammount;
		echo("reload?");
		    centerPrint(%obj.client, "<just:right>0/8");
}
function garandImage::checkammo(%this,%obj,%slot)
{
    if(%obj.ammo["garand"]$="")%obj.ammo["garand"]=$ammo::default["garand"];
    if(%obj.ammo["garand"])%obj.setimageammo(%slot,1);
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["garand"]@"/8");
}
//exec("add-ons/weapon_garand/server.cs");

